<?php

namespace App\Controller;

use App\Traits\JsonResponseTrait;
use App\Repository\PersonRepository;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;

class PersonController extends AbstractController
{
    use JsonResponseTrait;

    public function __construct(private PersonRepository $personRepository) {
    }

    #[Route('/api/person/{personId}', methods: ["GET"])]
    public function show(int $personId)
    {
        $person = $this->personRepository->get($personId);
        return $this->ok($person);
    }
}
