<?php

namespace App\Entity\Abstraction;

use Symfony\Component\Serializer\Serializer;
use Symfony\Component\Serializer\Normalizer\ObjectNormalizer;
use Symfony\Component\Serializer\Normalizer\AbstractNormalizer;
use Symfony\Component\Serializer\Normalizer\AbstractObjectNormalizer;

class BaseEntity {
    protected array $hidden = [];
    protected array $map = [];
    private array $systemParams = ['hidden', 'map', 'systemParams'];
    public function toArray() {
        $output = [];
        $defaultContext = [
            AbstractNormalizer::CIRCULAR_REFERENCE_HANDLER => function ($object, $format, $context) {
                return '$' . basename(str_replace('\\', '/', $object::class));
            },
        ];
        $normalizers = [new ObjectNormalizer(defaultContext: $defaultContext)];
        $serializer = new Serializer($normalizers);
        $array = $serializer->normalize($this, null, [ AbstractObjectNormalizer::ENABLE_MAX_DEPTH => true ]);

        $hidden = array_merge($this->hidden, $this->systemParams);
        foreach ($array as $key => $value) {
            if (in_array($key, $hidden)) {
                continue;
            }
            if (isset($this->map[$key])) {
                $key = $this->map[$key];
            }
            $output[$key] = $value;
        }
        return $output;
    }
}