import { Route } from '@angular/router';
import { ProfileEditBasicsComponent } from './components/profile-edit-basics/profile-edit-basics.component';
import { ProfileEditCredentialsComponent } from './components/profile-edit-credentials/profile-edit-credentials.component';
import { ProfileEditHealthComponent } from './components/profile-edit-health/profile-edit-health.component';
import { ProfileEditRolesComponent } from './components/profile-edit-roles/profile-edit-roles.component';
import { ProfileEditSettingsComponent } from './components/profile-edit-settings/profile-edit-settings.component';
import { ProfileEditComponent } from './components/profile-edit/profile-edit.component';
import { ProfileTabEnum } from './enums/profile-tab.enum';

export const profileTabRoutes: Route[] = [
    {
        path: 'health',
        component: ProfileEditHealthComponent,
        data: {
            tab: ProfileTabEnum.Health,
        },
    },
    {
        path: 'roles',
        component: ProfileEditRolesComponent,
        data: {
            tab: ProfileTabEnum.Roles,
        },
    },
    {
        path: 'basics',
        component: ProfileEditBasicsComponent,
        data: {
            tab: ProfileTabEnum.Basics,
        },
    },
    {
        path: 'credentials',
        component: ProfileEditCredentialsComponent,
        data: {
            tab: ProfileTabEnum.Credentials,
        },
    },
    {
        path: 'settings',
        component: ProfileEditSettingsComponent,
        data: {
            tab: ProfileTabEnum.Settings,
        },
    },
];

export const profileRoutes: Route[] = [
    {
        path: '',
        component: ProfileEditComponent,
        children: profileTabRoutes,
    },
    {
        path: ':personId',
        component: ProfileEditComponent,
        children: profileTabRoutes,
    },
];
