import { NgModule, Type } from '@angular/core';
import { CommonModule } from '@angular/common';
import { NotFoundComponent } from './components/not-found/not-found.component';
import { TranslateLoader, TranslateModule } from '@ngx-translate/core';
import { HttpLoaderFactory } from 'src/app/app.module';
import { HttpClient } from '@angular/common/http';
import { MaterialModule } from '../material/material.module';
import { LoaderComponent } from './components/loader/loader.component';

const componentList: (any[] | Type<any>)[] = [
    LoaderComponent,
];

@NgModule({
  declarations: [
    NotFoundComponent,
    ...componentList,
  ],
  exports: [
      ...componentList,
  ],
  imports: [
    CommonModule,
    MaterialModule,
    TranslateModule.forRoot({
        defaultLanguage: 'en',
        loader: {
          provide: TranslateLoader,
          useFactory: HttpLoaderFactory,
          deps: [HttpClient]
        }
      }),
    ],
})
export class SharedModule { }
